/*
	rxresolve: just like miamiresolve (and maybe more)

	Usage: rxresolve <host>
           rxresolve -s <servicename>
*/

parse arg host "-s" serv .

if ~show("L","rxsocket.library") then
	if ~addLib("rxsocket.library",0,-30) then do
		say "can't find rxsocket.library"
		exit
	end

if host="" then
	if serv="" then call usage()
	else call findServ(serv)
else
	if host="?" then call usage()
	else call findHost(host)

/****************************************************************************/

Usage: PROCEDURE
	say "Usage: rxresolve host"
	say "       rxresolve -s servicename"
	exit

/****************************************************************************/

findServ: PROCEDURE
parse arg serv

	if DataType(serv,NUM) then res = GetServByPort("SERV",serv,"tcp")
	else res = GetServByName("SERV",serv,"tcp")

	if ~res then do
		say "Service <" || serv || "> not found."
		exit
	end

	say "service:" serv.servname

	if serv.servaliases.num~=0 then do
		say "aliases:"
		do i = 0 to serv.servaliases.num-1
			say "   " serv.servaliases.i
		end
	end

	say "port:" serv.servport

	exit

/****************************************************************************/

findHost: PROCEDURE
parse arg host

	if IsDotAddr(host) then res = GetHostByAddr("HE",host)
	else res = GetHostByname("HE",host)

	if ~res then do
		say "Host <" || host || "> not found (" || HostErrorstring(HostErrorNo()) || ")."
		exit
	end

	say "host:" he.hostname

	if he.hostaliases.num ~= 0 then do
		say "aliases:"
		do i = 0 to he.hostaliases.num-1
			say "   " he.hostaliases.i
		end
	end

	say "address list:"
	do i = 0 to he.hostaddrlist.num-1
		say "   " he.hostaddrlist.i
	end

	exit

/****************************************************************************/
